from zeep import Client
import base64
from datetime import datetime
import requests
import json
from requests_toolbelt.utils import dump
import os
import logging
from datetime import date

today = date.today()
today = today.strftime("%d_%m_%Y")
logging.basicConfig(filename=("/usr/home/shumeeshumee/domains/python.shumeeshumee.usermd.net/public_python/logs/" + today +".log"), level=logging.INFO, format='%(asctime)s %(levelname)s:%(message)s', datefmt='%Y-%m-%d %H:%M:%S')

class DHL24WebAPIClient:
    WSDL = 'https://dhl24.com.pl/webapi2'
    def __init__(self):
        self.client = Client(self.WSDL)
        self.ship_ID = None
        self.order_id = None
        self.output_file_path = None 
        self.pole_b2b = None

    def RequestExtraField(self, order_id=593967419):
        url= "https://api.baselinker.com/connector.php"
        method_params1 = {            
            "order_id": order_id,
            "include_custom_extra_fields": "true"
            }
        headers = {
            "token" : "1426-10044-8TA3V6MQU7M54479DKBFTXXZR88EJDGBHF8D1XWRP991H8Z4N99ZF9JOKTFX26RI",
            "method": "getOrders",
            "parameters": json.dumps(method_params1),
        }
        response = requests.post(url,data=headers)
        if response.status_code == 200:
            parsed_response = json.loads(response.text)
            if 'orders' in parsed_response and len(parsed_response['orders']) > 0:
                custom_extra_fields = parsed_response['orders'][0]['custom_extra_fields']
                self.pole_b2b = custom_extra_fields.get('36415', None)
            else:
                logging.info("Brak zamówień w odpowiedzi.")
        else:
            logging.info(f"Błąd podczas wykonywania żądania. Kod odpowiedzi: {response.status_code}")
    def create_shipments(self, order_id):
        data = datetime.today()
        formatted_date = data.strftime("%Y-%m-%d")
        self.order_id = order_id
        request_data = {
        'authData': {
        'username': 'shumeepl_Zml',
        'password': 'Shumee321!',
    },
    'shipments': {
        'item': {
            'shipper': {
                'name': 'Shumee',
                'postalCode': '90739',
                'city': 'Łódź',
                'street': 'Aleja 1 maja',
                'houseNumber': '31/33/6',
                'contactPhone': '422144439',
            },
            'receiver': {
                'addressType': 'B',
                'country': 'PL',
                'name': 'Shumee',
                'postalCode': '90739',
                'city': 'Łódź',
                'street': 'Aleja 1 maja',
                'houseNumber': '31/33',
                'contactPerson': 'BOK',
                'contactPhone': '422144439',
                'contactEmail': 'kontakt@shumee.pl',
            },
            'pieceList': {
                'item': [
                    {
                        'type': 'PACKAGE',
                        'width': '10',
                        'height': '10',
                        'length': '10',
                        'weight': '10',
                        'quantity': '1',
                    },
                ],
            },
            'payment': {
                'paymentMethod': 'BANK_TRANSFER',
                'payerType': 'SHIPPER',
                'accountNumber': '2479266',
            },
            'service': {
                'product': 'AH',
            },
            'shipmentDate': formatted_date,
            'content': order_id,
            'skipRestrictionCheck': 'TRUE',
            'comment': self.pole_b2b
        },
    },}
        response1 = self.client.service.createShipments(**request_data)
        if response1:
            second_item = response1[0]
            self.ship_ID = second_item['shipmentId']
        return response1
    def get_labels(self):
        if self.ship_ID:
            request_data = {
                'authData': {
                    'username': 'shumeepl_Zml',
                    'password': 'Shumee321!',
                },
                'itemsToPrint': {
                    'item': [
                        {
                            'labelType': 'BLP',
                            'shipmentId': self.ship_ID,
                        },
                    ],
                },
            }
            response2 = self.client.service.getLabels(**request_data)
            return response2
        else:
            logging.info("Brak numeru przesyłki. Utwórz przesyłkę przed pobraniem etykiety.")
            return None
    def save_label_to_pdf(self, label_data, output_folder):
        if label_data:
            base64_pdf_data = label_data
            decoded_pdf_data = base64.b64decode(base64_pdf_data)
            self.output_file_path = os.path.join(output_folder, f"Label{self.ship_ID}.pdf")
            with open(self.output_file_path, 'wb') as pdf_file:
                pdf_file.write(decoded_pdf_data)
            logging.info(f"Etykieta została zapisana jako {self.output_file_path}")
        else:
            logging.info("Nie można zapisać etykiety do pliku PDF.")
    def Send_TO_BL(self, order_id):
        url = "https://api.baselinker.com/connector.php"
        method_params = {
        "order_id": order_id,
        "custom_extra_fields": {
            "40294": "shumeeshumee.usermd.net/others/dhl_labels/Label"+self.ship_ID+".pdf"
            }
        }
        token = "1426-10044-8TA3V6MQU7M54479DKBFTXXZR88EJDGBHF8D1XWRP991H8Z4N99ZF9JOKTFX26RI"
        headers = {
        'token' : token,
        'method': 'setOrderFields',
        'parameters': json.dumps(method_params)
        }
        response = requests.post(url, data=headers)
        if response.status_code == 200:
            response_data = response.json()
            logging.info(str(response_data))
        else:
            
            logging.info(f"API request failed with status code: {response.status_code}")
        return
def main(args):
    logging.info("---------")
    logging.info("DHL LABEL")
    logging.info("---------")
    order_id = args['order_id']
    output_folder = '/usr/home/shumeeshumee/domains/shumeeshumee.usermd.net/public_html/others/dhl_labels'
    client = DHL24WebAPIClient()
    client.RequestExtraField(order_id=order_id)
    response1 = client.create_shipments(order_id=order_id)
    if response1:
        response2 = client.get_labels()
        client.save_label_to_pdf(response2[0]['labelData'],output_folder)
        client.Send_TO_BL(order_id)
        return f"Przesyłka została utworzona dla zamówienia o numerze: {order_id}"
    else:
        return "Błąd podczas tworzenia przesyłki."